#!/bin/bash

set -eu
shopt -s nullglob

LOG_PATH="/var/log/op5/logger"
DB_USER=op5lsu
DB_NAME=op5lsu

for f in $LOG_PATH/*; do
	chmod g+r "$f"
done

archive_path="$(psql -U $DB_USER -d $DB_NAME -t -c 'SELECT storage_path from settings' | sed 's/ //g')"
if [ -n "$archive_path" ]; then
	find "$archive_path" -name \*.bz2 -exec chmod g+r {} \;
fi

PGOPTIONS='--client-min-messages=warning' psql --quiet -U $DB_USER -d $DB_NAME -f up38to39.sql
